package mainapp;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AddFactoryAction extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        request.setCharacterEncoding("UTF-8");
        String name = request.getParameter("name");
        String address = request.getParameter("address");
        String owner = request.getParameter("owner");
        String phone = request.getParameter("phone");
        
        if (!isNotNullOrEmpty(name) || !isNotNullOrEmpty(address) || !isNotNullOrEmpty(owner) || !isNotNullOrEmpty(phone)) {
            request.setAttribute("errorMessage", "Παρακαλώ συμπληρώστε όλα τα πεδία");
            request.setAttribute("name", name);
            request.setAttribute("address", address);
            request.setAttribute("owner", owner);
            request.setAttribute("phone", phone);
            request.getRequestDispatcher("?action=add_factory").forward(request, response);
            return;
        }
        Map<String, String> fields = new HashMap<>();
        fields.put("name", name);
        fields.put("address", address);
        fields.put("owner", owner);
        fields.put("phone", phone);
        
        try {
            DB.insertRow("factory", fields);
        } catch (Exception ex) {
            request.setAttribute("errorMessage", "Συνέβει κάποιο σφάλμα. Παρακαλώ προσπαθήστε ξανά");
            request.getRequestDispatcher("?action=register").forward(request, response);
            return;
        }
        response.sendRedirect("?action=factories&insert=1");
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    protected boolean isNotNullOrEmpty (String str) {
        if (str == null || str.length() < 1) {
            return false;
        }
        return true;
    }
}
